(function($){

	$.fn.memoryGame = function(options){

		var randomIndex = function(array){
			if(array.length)
			return Math.floor((Math.random() * (array.length - 1)));
		}

		var init = function(){
			var el = $(this);
			var cardsContainer = el.children(".memory-cards");
			var arrayCards = [];

			var settings = $.extend({
				"choices":[],
				"feedbacks":[]
			},options);

			// Config Game

			var createCard = function(choice,index){
				var card = $('<div class="card" data-par="'+index+'">'+
						'<label>'+choice+'</label>'+
						'<img src="media/imagens/card_background.png"/>'+
					'</div>');
				return card;
			};

			var buildArrayCards = function(){
				for(var i = 0; i < settings["choices"].length;i++){
					var tempNum = randomIndex(settings["choices"]);
					arrayCards.push(createCard(settings["choices"][i],i));
					arrayCards.splice(tempNum,0,createCard(settings["choices"][i],i));
				}
				for(var i = 0; i < arrayCards.length;i++){
					arrayCards[i].appendTo(cardsContainer);
				}
				cardsContainer.children(".card").height(cardsContainer.children(".card").width());
				cardsContainer.children(".card").children("label").each(function(){
					var lY = $(this).parent().height()/2 - $(this).height()/2;
					$(this).css({top:lY});
				});
			}

			buildArrayCards();

			// Game Events
			var lastBtnClicked = null;
			var clicksCount = 0;
			var actualPar = [];
			var clicked = [];

			var testPar = function(event){

				if(actualPar[0] == actualPar[1]){
					$("#modalMemoryGame").find(".header > p").html(settings["choices"][actualPar[0]]);
					$("#modalMemoryGame").find(".content").html(settings["feedbacks"][actualPar[0]]);
					$(clicked[0]).off("click",onBtnClick);
					$(clicked[1]).off("click",onBtnClick);

					var pg = $('body > .page');
					pg.css({'opacity':0.1});
					var pgLeft = pg.offset().left;
						//console.log(pgLeft);
					get_modal_fade().fadeIn('fast');
					var modal = $("#modalMemoryGame")
					var meio = $(window).outerHeight()/2 - modal.height()/2 + $(window).scrollTop();
					modal.css({height:"auto"});
					modal.show().css({'top': meio, 'opacity': 1, 'left': pgLeft});
					TweenMax.from(modal, 0.5, {css:{height: 0, width:0}});

				}else{
					TweenMax.to($(clicked[0]),0.5,{rotationY:"90deg", onComplete:hideLabel, onCompleteParams:[$(clicked[0])]})
					TweenMax.to($(clicked[1]),0.5,{rotationY:"90deg", onComplete:hideLabel, onCompleteParams:[$(clicked[1])]})
				}

				lastBtnClicked = null;
				clicksCount = 0;
				actualPar = [];
				clicked = [];

			}

			var showLabel = function(card){
				card.children("label").show();
				card.children("img").hide();
				TweenMax.to(card,0.5,{rotationY:"0deg", onComplete: function(){
					if(clicksCount > 1){
						testPar();
					}
				}});
			}

			var hideLabel = function(card){
				card.children("label").hide();
				card.children("img").show();
				TweenMax.to(card,0.5,{rotationY:"0deg"})
			}

			var onBtnClick = function(){
				TweenMax.to($(this),0.5,{rotationY:"90deg", onComplete:showLabel, onCompleteParams:[$(this)]})
				if(clicksCount <= 1 && lastBtnClicked != $(".card").index($(this))){
					actualPar[clicksCount] = $(this).data("par");
					clicksCount ++;
					clicked.push($(".card").get($(".card").index($(this))));
					lastBtnClicked = $(".card").index($(this));
				}
			}

			$(window).resize(function(){
				cardsContainer.children(".card").height(cardsContainer.children(".card").width());
				cardsContainer.children(".card").children("label").each(function(){
					var lY = $(this).parent().height()/2 - $(this).height()/2;
					$(this).css({top:lY});
				});
			});

			setTimeout(function(){
				cardsContainer.children(".card").each(function(){
					TweenMax.to($(this),0.5,{rotationY:"90deg", onComplete:hideLabel, onCompleteParams:[$(this)]})
				})
			},3000)

			el.find(".card").on("click",onBtnClick);

		};
		return this.each(init);
	}

})(jQuery);